Mulgara - Bug #152

Exception on not-well-formed OPTIONAL queries
10/15/2008 09:15 PM - Paula Gearon
Resolution: fixed

Description

The W3C test include the following:
Nested-optionals with a shared variable that does not appear in
the middle pattern (a not well-formed query pattern as per

"Semantics and Complexity" of SPARQL

The query is:

PREFIX : <http://example/>

SELECT *
{
?X :name "paul"
{?Y :name "george" . OPTIONAL { ?X :email ?Z } }

}
There data is on the W3C site

On running this query we get:

org.mulgara.query.QueryException: Query failed
at org.mulgara.resolver.DatabaseSession.execute (DatabaseSession. java:754)
at org.mulgara.resolver.DatabaseSession.query (DatabaseSession. java:464)
at org.openrdf.sail.mulgara.MulgaraTripleSource.evaluate (MulgaraTripleSource. java:111)
at org.openrdf.sail.mulgara.MulgaraEvaluationStrategy.evaluate (MulgaraEvaluationStrategy. ja
va:50)
27 more
Caused by: org.mulgara.query.MulgaraTransactionException: Transaction rollback triggered
at org.mulgara.resolver.MulgaralnternalTransaction.implicitRollback (MulgaraInternalTransact
ion.java:516)
at org.mulgara.resolver.MulgaralnternalTransaction.execute (MulgaralnternalTransaction. java:
627)
at org.mulgara.resolver.DatabaseSession.execute (DatabaseSession. java:751)
30 more
Caused by: org.mulgara.query.QueryException: Failed to resolve constraintExpression
at org.mulgara.resolver.ConstraintOperations.resolveConstraintExpression (ConstraintOperatio
ns.java:197)
at org.mulgara.resolver.LocalQueryResolver.resolveE (LocalQueryResolver.java:269)
at org.mulgara.resolver.DatabaseOperationContext.doQuery (DatabaseOperationContext.java:786)
at org.mulgara.resolver.QueryOperation.execute (QueryOperation. java:139)
at org.mulgara.resolver.MulgaralnternalTransaction.execute (MulgaralnternalTransaction. java:
623)
31 more
Caused by: org.mulgara.query.TuplesException: Bad [[LocalNode]] in constraint. constraint.getElem
ent (0) returned a [[LocalNode]] with value: 0 constraint=[gn0 gnl449 gnl481 gnl369]
at org.mulgara.resolver.store.StatementStoreResolution.defineIndex (StatementStoreResolution
.java:308)
at org.mulgara.resolver.store.StatementStoreResolution.<init> (StatementStoreResolution. java
:156)
http://www.w3.org/2001/sw/DataAccess/tests/r2var-scope-join-1.ttl
resolver.store.StatementStoreResolution.reresolve (StatementStoreResolution. j
store.tuples.TuplesOperations.resolveNewlyBoundFreeNames (TuplesOperations. ja
store.tuples.TuplesOperations.unifyOperands (TuplesOperations. java:464)
store.tuples.TuplesOperations.join (TuplesOperations. java:244)

resolver.DefaultConstraintHandlers$5.resolve (DefaultConstraintHandlers. java:

resolver.ConstraintOperations.resolveConstraintExpression (ConstraintOperatio

Associated revisions

Revision 1323 - 10/16/2008 05:23 AM - Paula Gearon

Found and fixed a pair of bugs when all variables are shared between two sides of an
optional join. Also updated optionalJoin to handle left and right sides not sharing
variables (a cartesian product), and now handling projection to extra variables when
the optional part of a join is empty.

Fixes #152
Fixes #150

History

#1 - 10/16/2008 05:23 AM - Paula Gearon

- Status changed from New to Closed

- Resolution set to fixed

(In r1323) Found and fixed a pair of bugs when all variables are shared between two sides of an
optional join. Also updated optionalJoin to handle left and right sides not sharing

variables (a cartesian product), and now handling projection to extra variables when

the optional part of a join is empty.

Fixes #152
Fixes #150
https://code.mulgara.org/projects/mulgara/repository/3/revisions/1323
https://code.mulgara.org/issues/152
https://code.mulgara.org/issues/150
http://www.tcpdf.org

